﻿-- Maul Stuff 
-- For tracking rage dump
-- Author: Shifte

if UnitClass("player") ~= "Warrior" and UnitClass("player") ~= "Druid" then return end

-------------------------------------------------
-- CONFIG RAGE THRESHOLD (Range between 30 - 100)
-------------------------------------------------
local MSRage = 60
---


local MSSpell = nil
local BTLoaded = false

function MaulStuff_Load()
	if IsAddOnLoaded("Bartender4") then		
		MaulStuff_BT4ActionBars = Bartender4:GetModule("ActionBars")
			
		if not MaulStuff_BT4ActionBars.actionbars then
			hooksecurefunc(MaulStuff_BT4ActionBars,"OnEnable",MaulStuff_ButtonUpdateA)
		else
			MaulStuff_ButtonUpdateA()
		end
	elseif tullaRange ~= nil then
		hooksecurefunc(tullaRange,"UpdateButtonUsable",MaulStuff_ButtonUpdate)
	else
		hooksecurefunc("ActionButton_OnUpdate", MaulStuff_ButtonUpdate)
	end	
end

local MaulStuff_Init = CreateFrame("Frame")
MaulStuff_Init:RegisterEvent("PLAYER_ENTERING_WORLD")
MaulStuff_Init:SetScript("OnEvent", function(self, event)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	if UnitClass("player") == "Warrior" then
		MSSpell = 78
	elseif UnitClass("player") == "Druid" then
		MSSpell = 6807
	end
	if MSRage < 30 then MSRage = 30 end
	local spellName = (GetSpellInfo(MSSpell))
	DEFAULT_CHAT_FRAME:AddMessage("|cffff7d0aMaul Stuff|r v1.0.1: "..spellName..", "..MSRage,1,1,1)
	MaulStuff_Load()
end)

function MaulStuff_ButtonUpdateA()
	if BTLoaded ~= false then return end
	
	BTLoaded = true
	
	MaulStuff_BT4ActionBars = Bartender4:GetModule("ActionBars")
	
	for _, bar in MaulStuff_BT4ActionBars:GetAll() do
		for i=1, bar:GetButtons() do
			btn = bar.buttons[i]
			spelId = btn:GetSpellId() or 0
			if spelId == MSSpell then
				btn:HookScript("OnUpdate", MaulStuff_ButtonUpdateBT)
			end
		end
	end
end

function MaulStuff_ButtonUpdateBT(self)
	if UnitPower("player", 1) >= MSRage then
		ActionButton_ShowOverlayGlow(self)
	else
		ActionButton_HideOverlayGlow(self)
	end
end
		
function MaulStuff_ButtonUpdate(self)
	local spellId = select(2, GetActionInfo(self.action)) or 0
	
	if UnitPower("player", 1) >= MSRage and spellId == MSSpell then
		ActionButton_ShowOverlayGlow(self)
	elseif spellId == MSSpell then
		ActionButton_HideOverlayGlow(self)
	end
end

--SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame,spellId,"TEXTURES\\SPELLACTIVATIONOVERLAYS\\LOCK_AND_LOAD.BLP","BOTTOM",.9,255,255,255, true, false)
--SpellActivationOverlay_HideOverlays(SpellActivationOverlayFrame,spellId)